<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.3"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>NANO102/112 BSP: StdDriver/src/gpio.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../M0Banner_v2.jpg"/></td>
  <td id="projectalign">
   <div id="projectname">NANO102/112 BSP<span id="projectnumber">&#160;V3.04.000</span>
   </div>
   <div id="projectbrief">The Board Support Package for Nano102/112 Series</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.3 -->
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',false,false,'search.php','Search');
});
/* @license-end */
</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="../../dir_0d398eaf8b2db165a9197a6619ec9f0e.html">StdDriver</a></li><li class="navelem"><a class="el" href="../../dir_3abedc03644d33bc69016fb8a5546004.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle"><div class="title">gpio.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../d8/da0/gpio_8c.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/**************************************************************************/</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span><span class="preprocessor">#include &quot;<a class="code" href="../../da/d91/_nano1_x2_series_8h.html">Nano1X2Series.h</a>&quot;</span></div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span> </div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span> </div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span> </div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno"><a class="line" href="../../d0/d47/group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaa2d25bd7fd805f81e465e5f2f0f43123">   40</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d0/d47/group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaa2d25bd7fd805f81e465e5f2f0f43123">GPIO_SetMode</a>(<a class="code hl_struct" href="../../d4/dff/struct_g_p_i_o___t.html">GPIO_T</a> *gpio, uint32_t u32PinMask, uint32_t u32Mode)</div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>{</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span>    uint32_t i;</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span> </div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span>    <span class="keywordflow">for</span> (i=0; i&lt;<a class="code hl_define" href="../../d4/db2/group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gad5df1f52a4cc540fc739f23056584a04">GPIO_PIN_MAX</a>; i++)</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span>    {</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span>        <span class="keywordflow">if</span> (u32PinMask &amp; (1 &lt;&lt; i))</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>        {</div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span>            gpio-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga1d09c59b4451ee8cc8736c8078891386">PMD</a> = (gpio-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga1d09c59b4451ee8cc8736c8078891386">PMD</a> &amp; ~(0x3 &lt;&lt; (i &lt;&lt; 1))) | (u32Mode &lt;&lt; (i &lt;&lt; 1));</div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span>        }</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span>    }</div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span>}</div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span> </div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno"><a class="line" href="../../d0/d47/group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaec751ab5c00bcad980d782816df53cbd">   65</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d0/d47/group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaec751ab5c00bcad980d782816df53cbd">GPIO_EnableInt</a>(<a class="code hl_struct" href="../../d4/dff/struct_g_p_i_o___t.html">GPIO_T</a> *gpio, uint32_t u32Pin, uint32_t u32IntAttribs)</div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>{</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>    gpio-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga238fd487ce9252ecbab0003630cdeb27">IMD</a> |= (((u32IntAttribs &gt;&gt; 24) &amp; 0xFFUL) &lt;&lt; u32Pin);</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span>    gpio-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gaa332e6a57141c2ae9a44acc296a8ca18">IER</a> |= ((u32IntAttribs &amp; 0xFFFFFFUL) &lt;&lt; u32Pin);</div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>}</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span> </div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span> </div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno"><a class="line" href="../../d0/d47/group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga675532237c47dd6f69f325e27fd2e7e0">   82</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d0/d47/group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga675532237c47dd6f69f325e27fd2e7e0">GPIO_DisableInt</a>(<a class="code hl_struct" href="../../d4/dff/struct_g_p_i_o___t.html">GPIO_T</a> *gpio, uint32_t u32Pin)</div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>{</div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>    gpio-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga238fd487ce9252ecbab0003630cdeb27">IMD</a> &amp;= ~(1UL &lt;&lt; u32Pin);</div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>    gpio-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gaa332e6a57141c2ae9a44acc296a8ca18">IER</a> &amp;= ~((0x00010001UL) &lt;&lt; u32Pin);</div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>}</div>
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span> </div>
<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span> </div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span> <span class="comment">/* end of group NANO1X2_GPIO_EXPORTED_FUNCTIONS */</span></div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span> <span class="comment">/* end of group NANO1X2_GPIO_Driver */</span></div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span> <span class="comment">/* end of group NANO1X2_Device_Driver */</span></div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span> </div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span><span class="comment">/*** (C) COPYRIGHT 2014 Nuvoton Technology Corp. ***/</span></div>
<div class="ttc" id="a_nano1_x2_series_8h_html"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html">Nano1X2Series.h</a></div><div class="ttdoc">Nano102/112 peripheral access layer header file. This file contains all the peripheral register's def...</div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s_html_gad5df1f52a4cc540fc739f23056584a04"><div class="ttname"><a href="../../d4/db2/group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gad5df1f52a4cc540fc739f23056584a04">GPIO_PIN_MAX</a></div><div class="ttdeci">#define GPIO_PIN_MAX</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d7c/gpio_8h_source.html#l00032">gpio.h:32</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga675532237c47dd6f69f325e27fd2e7e0"><div class="ttname"><a href="../../d0/d47/group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga675532237c47dd6f69f325e27fd2e7e0">GPIO_DisableInt</a></div><div class="ttdeci">void GPIO_DisableInt(GPIO_T *gpio, uint32_t u32Pin)</div><div class="ttdoc">Disable GPIO interrupt.</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/da0/gpio_8c_source.html#l00082">gpio.c:82</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_gaa2d25bd7fd805f81e465e5f2f0f43123"><div class="ttname"><a href="../../d0/d47/group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaa2d25bd7fd805f81e465e5f2f0f43123">GPIO_SetMode</a></div><div class="ttdeci">void GPIO_SetMode(GPIO_T *gpio, uint32_t u32PinMask, uint32_t u32Mode)</div><div class="ttdoc">Set GPIO operation mode.</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/da0/gpio_8c_source.html#l00040">gpio.c:40</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_gaec751ab5c00bcad980d782816df53cbd"><div class="ttname"><a href="../../d0/d47/group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaec751ab5c00bcad980d782816df53cbd">GPIO_EnableInt</a></div><div class="ttdeci">void GPIO_EnableInt(GPIO_T *gpio, uint32_t u32Pin, uint32_t u32IntAttribs)</div><div class="ttdoc">Enable GPIO interrupt.</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/da0/gpio_8c_source.html#l00065">gpio.c:65</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2__legacy___constants_html_ga1d09c59b4451ee8cc8736c8078891386"><div class="ttname"><a href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga1d09c59b4451ee8cc8736c8078891386">GPIO_T::PMD</a></div><div class="ttdeci">__IO uint32_t PMD</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l04213">Nano1X2Series.h:4213</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2__legacy___constants_html_ga238fd487ce9252ecbab0003630cdeb27"><div class="ttname"><a href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga238fd487ce9252ecbab0003630cdeb27">GPIO_T::IMD</a></div><div class="ttdeci">__IO uint32_t IMD</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l04315">Nano1X2Series.h:4315</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2__legacy___constants_html_gaa332e6a57141c2ae9a44acc296a8ca18"><div class="ttname"><a href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gaa332e6a57141c2ae9a44acc296a8ca18">GPIO_T::IER</a></div><div class="ttdeci">__IO uint32_t IER</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l04613">Nano1X2Series.h:4613</a></div></div>
<div class="ttc" id="astruct_g_p_i_o___t_html"><div class="ttname"><a href="../../d4/dff/struct_g_p_i_o___t.html">GPIO_T</a></div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l04074">Nano1X2Series.h:4075</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Oct 18 2024 12:20:31 for NANO102/112 BSP by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.3
</small></address>
</body>
</html>
